<template>
    <v-card>
        <ValidationObserver ref="observer" v-slot="{ validate, reset }">
            <v-container class="px-8">
                <v-row>
                    <v-col>
                        <div class="title text--primary">{{ $t(mode + '_', [$t('account')]) }}</div>
                    </v-col>
                </v-row>

                <v-divider></v-divider>

                <v-row>
                    <v-col>
                        <div class="subtitle-1 text--secondary">{{ $t('account_', [$tc('type', 1)]) }}</div>
                    </v-col>
                </v-row>

                <v-row class="ml-2">
                    <v-col lg="4">
                        <div class="field-label">{{ $t('role') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="role" rules="required">
                            <v-role-select
                                v-model="localValue.role_id"
                                :roles.sync="roles"
                                :placeholder="$t('account_', [$t('role')])"
                                :errors="errors"
                            ></v-role-select>
                        </ValidationProvider>
                    </v-col>
                </v-row>

                <v-divider></v-divider>

                <v-row>
                    <v-col>
                        <div class="subtitle-1 text--secondary">{{ $t('account_', [$t('info')]) }}</div>
                    </v-col>
                </v-row>

                <v-row class="ml-2">
                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('first_name') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="first_name" rules="required">
                            <v-text-field
                                v-model="localValue.first_name"
                                :placeholder="$t('account_', [$t('first_name')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col class="col-xs-12">
                        <div class="field-label">{{ $t('last_name') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="last_name" rules="required">
                            <v-text-field
                                v-model="localValue.last_name"
                                :placeholder="$t('account_', [$t('last_name')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col v-if="!isEditMode" class="col-xs-12 col-sm-12 col-md-12 col-lg-6">
                        <div class="field-label">{{ $t('email') }}</div>
                        <ValidationProvider v-slot="{ errors, pending }" name="email" rules="required|email">
                            <v-text-field
                                v-model="localValue.email"
                                :placeholder="$t('account_', [$t('email')])"
                                :loading="pending"
                                :error-messages="errors"
                                prepend-inner-icon="mdi-at"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col class="col-xs-12 col-sm-12 col-md-12 col-lg-6">
                        <div class="field-label">{{ $t('mobile') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="mobile" rules="required|mobile">
                            <v-tel-input
                                v-model="localValue.mobile"
                                :defaultCountry="defaultCountry"
                                :placeholder="$t('account_', [$t('mobile')])"
                                :errors="errors"
                            ></v-tel-input>
                        </ValidationProvider>
                    </v-col>
                </v-row>

                <template v-if="mode === 'create'">
                    <v-divider></v-divider>

                    <v-row>
                        <v-col>
                            <div class="subtitle-1 text--secondary">{{ $t('account_', [$t('credential')]) }}</div>
                        </v-col>
                    </v-row>

                    <v-row class="ml-2">
                        <v-col>
                            <div class="field-label">{{ $t('password') }}</div>
                            <ValidationProvider v-slot="{ errors }" name="password" rules="required|min:8">
                                <v-text-field
                                    v-model="localValue.password"
                                    :placeholder="$t('account_', [$t('password')])"
                                    :error-messages="errors"
                                    prepend-inner-icon="mdi-lock"
                                    type="password"
                                    outlined
                                ></v-text-field>
                            </ValidationProvider>
                        </v-col>

                        <v-col>
                            <div class="field-label">{{ $t('password_confirmation') }}</div>
                            <ValidationProvider
                                v-slot="{ errors }"
                                name="password_confirmation"
                                rules="required|password:@password"
                            >
                                <v-text-field
                                    v-model="localValue.password_confirmation"
                                    :placeholder="$t('account_', [$t('password_confirmation')])"
                                    :error-messages="errors"
                                    prepend-inner-icon="mdi-lock"
                                    type="password"
                                    outlined
                                ></v-text-field>
                            </ValidationProvider>
                        </v-col>
                    </v-row>
                </template>

                <template v-if="showAffiliateField">
                    <v-divider></v-divider>
                    <v-row>
                        <v-col>
                            <div class="subtitle-1 text--secondary">{{ $t('affiliate_info') }}</div>
                        </v-col>
                    </v-row>

                    <v-row class="ml-2">
                        <v-col lg="6">
                            <div class="field-label">{{ $t('commission') }}</div>
                            <ValidationProvider v-slot="{ errors }" name="commission" rules="min_value:0|decimal">
                                <v-text-field
                                    v-model="localValue.affiliate.commission"
                                    :placeholder="$t('account_', [$t('commission')])"
                                    :error-messages="errors"
                                    outlined
                                ></v-text-field>
                            </ValidationProvider>
                        </v-col>

                        <v-col v-if="showAgentSelectionField" lg="6">
                            <div class="field-label">{{ $t('agent') }}</div>
                            <v-superior-select v-model="localValue.affiliate.parent_id"></v-superior-select>
                        </v-col>
                    </v-row>

                    <v-row class="ml-2">
                        <v-col lg="6">
                            <div class="field-label">{{ $t('discount_field', [$t('ref_code')]) }}</div>
                            <ValidationProvider v-slot="{ errors }" name="discount" rules="min_value:0|decimal">
                                <v-discount-input
                                    v-model="localValue.affiliate.discount_code.discount"
                                    :type.sync="localValue.affiliate.discount_code.discount_type_id"
                                    :method.sync="localValue.affiliate.discount_code.discount_method_id"
                                    :errors="errors"
                                ></v-discount-input>
                            </ValidationProvider>
                        </v-col>
                    </v-row>
                </template>

                <v-row>
                    <v-col class="text-center">
                        <v-btn
                            v-if="clearable"
                            class="text--white mx-2"
                            color="error"
                            large
                            @click="internalClear"
                        >
                            <v-icon>mdi-clear</v-icon>
                            {{ $t('clear') }}
                        </v-btn>
                        <v-btn
                            class="text--white mx-2"
                            color="primary"
                            large
                            @click="internalSave"
                            :loading="submit"
                        >
                            <v-icon>mdi-content-save</v-icon>
                            {{ $t('save') }}
                        </v-btn>
                    </v-col>
                </v-row>
            </v-container>
        </ValidationObserver>
    </v-card>
</template>


<script>
  import {ValidationObserver, ValidationProvider} from "vee-validate";
  import VTelInput from "../VTelInput";
  import VRoleSelect from "../VRoleSelect";
  import VDiscountInput from "../VDiscountInput";
  import VSuperiorSelect from "../VSuperiorSelect";
  import {mapMutations} from "vuex";

  export default {
      name: "AccountForm",
      components: {
          VSuperiorSelect,
          VDiscountInput,
          VRoleSelect,
          VTelInput,
          ValidationObserver,
          ValidationProvider,
      },
      props: {
          value: {
              type: Object,
              required: true,
          },
          clearable: {
              type: Boolean,
              default: true,
          },
          mode: {
              type: String,
              default: "create",
              validator: (value) => ["create", "edit"].indexOf(value) !== -1,
          },
      },

      data: () => ({
          isDirty: false,
          submit: false,
          validating: false,
          superiors: [],
          roles: [],
          defaultCountry: "",
          dialog: false,
      }),

      computed: {
          localValue: {
              get() {
                  return this.value;
              },
              set(val) {
                  this.$emit("input", val);
              },
          },

          isEditMode() {
              return this.mode === "edit";
          },

          showAffiliateField() {
              return false;
              // if (!!this.roles.length) {
              //   const role = this.roles.find(
              //     (role) => role.id === this.localValue.role_id
              //   );
              //   return role !== undefined && role.name !== "admin";
              // } else {
              //   return false;
              // }
          },

          showAgentSelectionField() {
              if (!!this.roles.length) {
                  const role = this.roles.find(
                      (role) => role.id === this.localValue.role_id
                  );
                  return role !== undefined && role.name === "agent";
              } else {
                  return false;
              }
          },
      },

      mounted() {
          if (this.mode === "create") {
              this.ipLookup();
          }
      },

      methods: {
          ...mapMutations('snackbar', [
              'success',
              'error'
          ]),

          closeDialog() {
              this.dialog = false;
          },

          inputOnlyMode() {
              return {
                  on: ["input"],
                  debounce: 500,
              };
          },

          internalClear() {
              let defaultObject = {
                  first_name: "",
                  last_name: "",
                  email: "",
                  role_id: 0,
                  mobile: "",
                  affiliate: {
                      commission: 0,
                      parent_id: 0,
                      discount_code: {
                          discount: 0,
                          discount_type: 2,
                      },
                  },
              };

              if (this.mode === "create") {
                  defaultObject = {
                      ...defaultObject,
                      password: "",
                      password_confirmation: "",
                  };
              }

              this.$emit("input", defaultObject);

              this.$refs.observer.reset();
          },

          internalSave() {
              this.submit = true;

              this.$refs.observer.validate().then((valid) => {
                  if (valid) {
                      this.callApi(this.prepareData()).then((data) => {
                          this.submit = !this.submit;
                          if (data.status === 200) {
                              this.$router.push("/account");
                          }
                      });
                  } else {
                      this.submit = false;
                  }
              });
          },

          callApi(data) {
              if (this.mode === "create") {
                  return new Promise((resolve, reject) => {
                      axios
                          .post("api/accounts", data)
                          .then((response) => {
                              this.success(this.$t('account_action.created'));
                              resolve({
                                  status: response.status,
                              });
                          })
                          .catch((error) => {
                              reject(error.response.data);
                          });
                  });
              } else {
                  return new Promise((resolve, reject) => {
                      axios
                          .put("api/accounts/" + this.value.id, data)
                          .then((response) => {
                              this.success(this.$t('account_action.updated'));
                              resolve({
                                  status: response.status,
                              });
                          })
                          .catch((error) => {
                              reject(error.response.data);
                          });
                  });
              }
          },

          ipLookup() {
              axios
                  .get("http://ip-api.com/json")
                  .then(({data}) => {
                      this.defaultCountry = data.countryCode;
                  })
                  .catch((error) => {
                      console.error("Request failed http://ip-api.com/json");
                  });
          },

          prepareData() {
              let data = {...this.localValue};

              if (data.affiliate.parent_id === 0) {
                  data.affiliate.parent_id = undefined;
                  delete data.affiliate;
              }

              if (this.mode === "edit") {
                  if (!this.isEmailDirty) {
                      data.email = undefined;
                  }
                  delete data.password;
                  delete data.password_confirmation;
              }
              return data;
          },
      },
  };
</script>

<style scoped>
</style>
